com.fasterxml.jackson.databind.type

## Class ReferenceType

- java.lang.Object
- - com.fasterxml.jackson.core.type.ResolvedType
  - - com.fasterxml.jackson.databind.JavaType
    - - com.fasterxml.jackson.databind.type.TypeBase
      - - com.fasterxml.jackson.databind.type.SimpleType
        - - com.fasterxml.jackson.databind.type.ReferenceType

- All Implemented Interfaces:
    JsonSerializable, Serializable, Type

      public class ReferenceType
      extends SimpleType

  Specialized `SimpleType` for types that are referential types, that is, values that can be dereferenced to another value (or null), of different type. Referenced type is accessible using `getContentType()`.
  Since:
    2.6
  See Also:
    Serialized Form

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from interface com.fasterxml.jackson.databind.JsonSerializable

      `JsonSerializable.Base`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected JavaType` | `_anchorType` Essential type used for type ids, for example if type id is needed for referencing type with polymorphic handling.
    `protected JavaType` | `_referencedType`

    - ### Fields inherited from class com.fasterxml.jackson.databind.type.TypeBase

      `_bindings, _superClass, _superInterfaces`

    - ### Fields inherited from class com.fasterxml.jackson.databind.JavaType

      `_asStatic, _class, _hash, _typeHandler, _valueHandler`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `protected` | `ReferenceType(Class<?> cls, TypeBindings bindings, JavaType superClass, JavaType[] superInts, JavaType refType, JavaType anchorType, Object valueHandler, Object typeHandler, boolean asStatic)`
    `protected` | `ReferenceType(TypeBase base, JavaType refType)` Constructor used when upgrading into this type (via `upgradeFrom(com.fasterxml.jackson.databind.JavaType, com.fasterxml.jackson.databind.JavaType)`, the usual way for `ReferenceType`s to come into existence.

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods Deprecated Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected JavaType` | `_narrow(Class<?> subclass)` Deprecated.
    `protected String` | `buildCanonicalName()`
    `static ReferenceType` | `construct(Class<?> cls, JavaType refType)` Deprecated.
    `static ReferenceType` | `construct(Class<?> cls, TypeBindings bindings, JavaType superClass, JavaType[] superInts, JavaType refType)`
    `boolean` | `equals(Object o)`
    `JavaType` | `getAnchorType()`
    `JavaType` | `getContentType()`
    `StringBuilder` | `getErasedSignature(StringBuilder sb)` Method for accessing signature without generic type information, in form compatible with all versions of JVM, and specifically used for type descriptions when generating byte code.
    `StringBuilder` | `getGenericSignature(StringBuilder sb)`
    `JavaType` | `getReferencedType()`
    `boolean` | `hasContentType()` Accessor that allows determining whether `JavaType.getContentType()` should return a non-null value (that is, there is a "content type") or not.
    `boolean` | `isAnchorType()` Convenience accessor that allows checking whether this is the anchor type itself; if not, it must be one of supertypes that is also a `ReferenceType`
    `boolean` | `isReferenceType()`
    `JavaType` | `refine(Class<?> rawType, TypeBindings bindings, JavaType superClass, JavaType[] superInterfaces)` Mutant factory method that will try to create and return a sub-type instance for known parameterized types; for other types will return `null` to indicate that no just refinement makes necessary sense, without trying to detect special status through implemented interfaces.
    `String` | `toString()`
    `static ReferenceType` | `upgradeFrom(JavaType baseType, JavaType refdType)` Factory method that can be used to "upgrade" a basic type into collection-like one; usually done via `TypeModifier`
    `JavaType` | `withContentType(JavaType contentType)` Mutant factory method that may be called on structured types that have a so-called content type (element of arrays, value type of Maps, referenced type of referential types), and will construct a new instance that is identical to this instance, except that it has specified content type, instead of current one.
    `ReferenceType` | `withContentTypeHandler(Object h)` Mutant factory method that will construct a new instance that is identical to this instance, except that it will have specified content type (element type for arrays, value type for Maps and so forth) handler assigned.
    `ReferenceType` | `withContentValueHandler(Object h)` Mutant factory method that will construct a new instance that is identical to this instance, except that it will have specified content value handler assigned.
    `ReferenceType` | `withStaticTyping()` Method that can be called to get a type instance that indicates that values of the type should be handled using "static typing" for purposes of serialization (as opposed to "dynamic" aka runtime typing): meaning that no runtime information is needed for determining serializers to use.
    `ReferenceType` | `withTypeHandler(Object h)` "Copy method" that will construct a new instance that is identical to this instance, except that it will have specified type handler assigned.
    `ReferenceType` | `withValueHandler(Object h)` Mutant factory method that will construct a new instance that is identical to this instance, except that it will have specified value handler assigned.

    - ### Methods inherited from class com.fasterxml.jackson.databind.type.SimpleType

      `construct, constructUnsafe, isContainerType`

    - ### Methods inherited from class com.fasterxml.jackson.databind.type.TypeBase

      `_bogusSuperClass, _classSignature, containedType, containedTypeCount, containedTypeName, findSuperType, findTypeParameters, getBindings, getInterfaces, getSuperClass, serialize, serializeWithType, toCanonical`

    - ### Methods inherited from class com.fasterxml.jackson.databind.JavaType

      `containedTypeOrUnknown, forcedNarrowBy, getContentTypeHandler, getContentValueHandler, getErasedSignature, getGenericSignature, getKeyType, getParameterSource, getRawClass, getTypeHandler, getValueHandler, hasGenericTypes, hasHandlers, hashCode, hasRawClass, hasValueHandler, isAbstract, isArrayType, isCollectionLikeType, isConcrete, isEnumImplType, isEnumType, isFinal, isInterface, isJavaLangObject, isMapLikeType, isPrimitive, isThrowable, isTypeOrSubTypeOf, isTypeOrSuperTypeOf, useStaticType, withHandlersFrom`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface java.lang.reflect.Type

      `getTypeName`

- - ### Field Detail

    - #### _referencedType

          protected final JavaType _referencedType

    - #### _anchorType

          protected final JavaType _anchorType

      Essential type used for type ids, for example if type id is needed for referencing type with polymorphic handling. Typically initialized when a `SimpleType` is upgraded into reference type, but NOT changed if being sub-classed.
      Since:
        2.8

  - ### Constructor Detail

    - #### ReferenceType

          protected ReferenceType(Class<?> cls,
                                  TypeBindings bindings,
                                  JavaType superClass,
                                  JavaType[] superInts,
                                  JavaType refType,
                                  JavaType anchorType,
                                  Object valueHandler,
                                  Object typeHandler,
                                  boolean asStatic)

    - #### ReferenceType

          protected ReferenceType(TypeBase base,
                                  JavaType refType)

      Constructor used when upgrading into this type (via `upgradeFrom(com.fasterxml.jackson.databind.JavaType, com.fasterxml.jackson.databind.JavaType)`, the usual way for `ReferenceType`s to come into existence. Sets up what is considered the "base" reference type
      Since:
        2.7

  - ### Method Detail

    - #### upgradeFrom

          public static ReferenceType upgradeFrom(JavaType baseType,
                                                  JavaType refdType)

      Factory method that can be used to "upgrade" a basic type into collection-like one; usually done via `TypeModifier`
      Parameters:
        `baseType` - Resolved non-reference type (usually `SimpleType`) that is being upgraded
        `refdType` - Referenced type; usually the first and only type parameter, but not necessarily
      Since:
        2.7

    - #### construct

          public static ReferenceType construct(Class<?> cls,
                                                TypeBindings bindings,
                                                JavaType superClass,
                                                JavaType[] superInts,
                                                JavaType refType)

      Since:
        2.7

    - #### construct

          @Deprecated
          public static ReferenceType construct(Class<?> cls,
                                                            JavaType refType)

      Deprecated.

    - #### withContentType

          public JavaType withContentType(JavaType contentType)

      Description copied from class: `JavaType`
      Mutant factory method that may be called on structured types that have a so-called content type (element of arrays, value type of Maps, referenced type of referential types), and will construct a new instance that is identical to this instance, except that it has specified content type, instead of current one. If content type is already set to given type, `this` is returned. If type does not have a content type (which is the case with `SimpleType`), `IllegalArgumentException` will be thrown.
      Overrides:
        `withContentType` in class `SimpleType`
      Returns:
        Newly created type instance

    - #### withTypeHandler

          public ReferenceType withTypeHandler(Object h)

      Description copied from class: `JavaType`
      "Copy method" that will construct a new instance that is identical to this instance, except that it will have specified type handler assigned.
      Overrides:
        `withTypeHandler` in class `SimpleType`
      Returns:
        Newly created type instance

    - #### withContentTypeHandler

          public ReferenceType withContentTypeHandler(Object h)

      Description copied from class: `JavaType`
      Mutant factory method that will construct a new instance that is identical to this instance, except that it will have specified content type (element type for arrays, value type for Maps and so forth) handler assigned.
      Overrides:
        `withContentTypeHandler` in class `SimpleType`
      Returns:
        Newly created type instance, with given

    - #### withValueHandler

          public ReferenceType withValueHandler(Object h)

      Description copied from class: `JavaType`
      Mutant factory method that will construct a new instance that is identical to this instance, except that it will have specified value handler assigned.
      Overrides:
        `withValueHandler` in class `SimpleType`
      Returns:
        Newly created type instance

    - #### withContentValueHandler

          public ReferenceType withContentValueHandler(Object h)

      Description copied from class: `JavaType`
      Mutant factory method that will construct a new instance that is identical to this instance, except that it will have specified content value handler assigned.
      Overrides:
        `withContentValueHandler` in class `SimpleType`
      Returns:
        Newly created type instance

    - #### withStaticTyping

          public ReferenceType withStaticTyping()

      Description copied from class: `JavaType`
      Method that can be called to get a type instance that indicates that values of the type should be handled using "static typing" for purposes of serialization (as opposed to "dynamic" aka runtime typing): meaning that no runtime information is needed for determining serializers to use. The main use case is to allow forcing of specific root value serialization type, and specifically in resolving serializers for contained types (element types for arrays, Collections and Maps).
      Overrides:
        `withStaticTyping` in class `SimpleType`

    - #### refine

          public JavaType refine(Class<?> rawType,
                                 TypeBindings bindings,
                                 JavaType superClass,
                                 JavaType[] superInterfaces)

      Description copied from class: `JavaType`
      Mutant factory method that will try to create and return a sub-type instance for known parameterized types; for other types will return `null` to indicate that no just refinement makes necessary sense, without trying to detect special status through implemented interfaces.
      Overrides:
        `refine` in class `SimpleType`

    - #### buildCanonicalName

          protected String buildCanonicalName()

      Overrides:
        `buildCanonicalName` in class `SimpleType`

    - #### _narrow

          @Deprecated
          protected JavaType _narrow(Class<?> subclass)

      Deprecated.
      Overrides:
        `_narrow` in class `SimpleType`

    - #### getContentType

          public JavaType getContentType()

      Overrides:
        `getContentType` in class `JavaType`

    - #### getReferencedType

          public JavaType getReferencedType()

      Overrides:
        `getReferencedType` in class `JavaType`

    - #### hasContentType

          public boolean hasContentType()

      Description copied from class: `JavaType`
      Accessor that allows determining whether `JavaType.getContentType()` should return a non-null value (that is, there is a "content type") or not. True if `JavaType.isContainerType()` or `ResolvedType.isReferenceType()` return true.
      Overrides:
        `hasContentType` in class `SimpleType`

    - #### isReferenceType

          public boolean isReferenceType()

      Overrides:
        `isReferenceType` in class `ResolvedType`

    - #### getErasedSignature

          public StringBuilder getErasedSignature(StringBuilder sb)

      Description copied from class: `JavaType`
      Method for accessing signature without generic type information, in form compatible with all versions of JVM, and specifically used for type descriptions when generating byte code.
      Overrides:
        `getErasedSignature` in class `SimpleType`
      Parameters:
        `sb` - StringBuilder to append signature to
      Returns:
        StringBuilder that was passed in; returned to allow call chaining

    - #### getGenericSignature

          public StringBuilder getGenericSignature(StringBuilder sb)

      Overrides:
        `getGenericSignature` in class `SimpleType`
      Parameters:
        `sb` - StringBuilder to append signature to
      Returns:
        StringBuilder that was passed in; returned to allow call chaining

    - #### getAnchorType

          public JavaType getAnchorType()

    - #### isAnchorType

          public boolean isAnchorType()

      Convenience accessor that allows checking whether this is the anchor type itself; if not, it must be one of supertypes that is also a `ReferenceType`

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `SimpleType`

    - #### equals

          public boolean equals(Object o)

      Overrides:
        `equals` in class `SimpleType`

Copyright © 2008–2020 FasterXML. All rights reserved.